-- Make out top level skg command and options table

SKG.OnSlashCommand = function ( self, command, text )
	local db = SKG.db.profile.Options.General
	assert( command == "/skg" )
	if ( text == "" ) then
		if ( SKG_Frame:IsVisible() ) then
			PlaySound("igMainMenuClose");
			SKG_Frame:Hide()
		else
			PlaySound("igMainMenuOpen");
			SKG_Frame:Show()
		end
	elseif ( text == "reset" ) then
		db.xPos = 100
		db.yPos = -100
		SKG_Frame:SetPoint( "TOPLEFT", UIParent, "TOPLEFT", 100, -100 )
		SKG_Frame:Show()
	else
		SKG_Print( "Need Usage message here" )
	end
end

SKG:AddSlashCommand( "OnSlashCommand", "/skg" )
-- For use with RockConfig once I get there:
-- SKG:SetConfigTable( SKG_options )
-- SKG:SetConfigSlashCommand( "/skg" )

function SKG:OnInitialize()
    -- Called when the addon is loaded
end

function SKG:OnEnable()
    -- Called when the addon is enabled
	local major, minor = SKG_getVersionComponents()
	SKG_Print( string.format( SKGL["SKG_MSG_ADDON_LOADED"], major, minor ) )
end

function SKG:OnDisable()
    -- Called when the addon is disabled
end

-- Frames used for resolving class conflicts during an import.

SKG.importClassSelections = {
	type = "group",
	handler = SKG,
	args = { },
}

-- Class chooser frame
	SKG_ChooseClassFrame = CreateFrame( "Frame", "SKG_ChooseClassFrame", UIParent)
	SKG_ChooseClassFrame:SetHeight( 125 )
	SKG_ChooseClassFrame:SetWidth( 256 )
	SKG_ChooseClassFrame:SetPoint( "CENTER", UIParent, "CENTER", 0, 0 )
	SKG_ChooseClassFrame:EnableMouse( true )
	SKG_ChooseClassFrame:SetMovable( false )
	SKG_ChooseClassFrame:SetFrameLevel( 1 )
	SKG_ChooseClassFrame:SetFrameStrata( "DIALOG" )
	SKG_ChooseClassFrame:Hide()

	local SKG_CCF_Texture = SKG_ChooseClassFrame:CreateTexture( "SKG_CCF_Texture", "ARTWORK" )
		SKG_CCF_Texture:SetTexture( [[Interface\Addons\SKG\BLP\GenericDialog]] )
		SKG_CCF_Texture:SetAllPoints( SKG_ChooseClassFrame )

	local SKG_CCF_TitleText = SKG_ChooseClassFrame:CreateFontString( "SKG_CCF_TitleText", "OVERLAY", "GameFontHighlight" )
		SKG_CCF_TitleText:SetText( SKGL["SKG_LBL_CCF_TITLE_TEXT"] )
		SKG_CCF_TitleText:SetPoint( "TOP", SKG_ChooseClassFrame, "TOP", 0, -15 )
		SKG_CCF_TitleText:SetJustifyH( "CENTER" )
		SKG_CCF_TitleText:SetHeight( 18 )
		SKG_CCF_TitleText:SetWidth( 200 )

	local SKG_CCF_NameText = SKG_ChooseClassFrame:CreateFontString( "SKG_CCF_NameText", "OVERLAY", "GameFontNormal" )
		SKG_CCF_NameText:SetText( "" )
		SKG_CCF_NameText:SetPoint( "TOP", SKG_ChooseClassFrame, "TOP", 0, -40 )
		SKG_CCF_NameText:SetJustifyH( "CENTER" )
		SKG_CCF_NameText:SetHeight( 18 )
		SKG_CCF_NameText:SetWidth( 200 )

	local SKG_CCF_ClassChooser = SKG_CreateButton( "SKG_CCF_ClassChooser", SKG_ChooseClassFrame, 21, 200,
		"TOP", SKG_CCF_NameText, "BOTTOM", 0, -2, "GameFontNormalSmall", "GameFontHighlightSmall", 
		SKGL["SKG_LBL_CCF_SELECTCLASS_TEXT"], "CENTER", "SKG_CCF_SELECTCLASS_TT" )

		-- onclick method
		SKG_CCF_ClassChooser:SetScript( "OnClick",
			function()
				Dewdrop:Register( this,
					'children', SKG.importClassSelections,
					'dontHook', true,
					'point', "TOP",
					'relativePoint', "BOTTOM"
				)
				this:SetScript( "OnClick",
					function()
						if Dewdrop:IsOpen( this ) then
							Dewdrop:Close()
						else
							Dewdrop:Open( this )
						end
					end
				)
				this:GetScript( "OnClick" )()
			end
		)

	local SKG_CCF_OK =  SKG_CreateButton( "SKG_CCF_OK", SKG_ChooseClassFrame, 21, 120,
		"TOP", SKG_CCF_ClassChooser, "BOTTOM", 0, -5, "GameFontNormalSmall", "GameFontHighlightSmall", 
		SKGL["SKG__SUBMIT"], "CENTER", "SKG__SUBMIT" )

		SKG_CCF_OK:SetScript( "OnClick", function ()
			-- Validate our data
			if SKG.importSelectedClass == 0 then
				SKG_Print( SKGL["SKG_ERROR_NOCLASSSELECTED"] )
			else
				SKG_ChooseClassFrame:Hide()
				SKG.Import.Players[SKG.importCurrPID].class = strupper( SKG_ClassNames[SKG.importSelectedClass] )
				SKG.importSelectedClass = 0
				SKG_CCF_ClassChooser:SetText( SKGL["SKG_LBL_CCF_SELECTCLASS_TEXT"] )

				-- and trigger the next one
				SKG_ImportTimerFrame:Show()
			end
		end )

-- init code for above frame
SKG.importClassSelections.args = {}
SKG.importSelectedClass = 0
for i=1, #SKG_ClassNames do
	local t = {
		type = "execute",
		name = SKG_ClassNames[i],
		desc = SKG_ClassNames[i],
		func = function ( val )
			SKG.importSelectedClass = val
			SKG_CCF_ClassChooser:SetText( SKGL["SKG_LBL_CCF_SELECTCLASS_TEXT"] .. ": " .. SKG_ClassNames[val] )
			Dewdrop:Close()
		end,
		passValue = i
	}
	tinsert( SKG.importClassSelections.args, t )
end
SKG_CCF_ClassChooser:Enable()


--This is a timer frame

SKG_ImportTimerFrame = CreateFrame("Frame",SKG_ImportTimerFrame,UIParent)
	SKG_ImportTimerFrame.t = 0
	SKG_ImportTimerFrame:SetScript("OnUpdate", function(self,elapsed)
		SKG_ImportTimerFrame.t = SKG_ImportTimerFrame.t + elapsed;
		if ( SKG_ImportTimerFrame.t > 1 ) then 
			SKG_ImportTimerFrame:Hide()
			SKG_ImportTimerFrame.t = 0
			-- Look through the SKG.Import.Players structure to find an
			-- entry that has no "Class" associated with it. If you find
			-- one, kick off the dialog to resolve that, and hide
			local pList = SKG.Import.Players
			local found = false
			local pName = ""
			local pClass = ""
			for PID, pInfo in pairs( pList ) do
				pClass = pInfo.class
				if ( pClass == "" ) then
					pName = pInfo.name
					SKG.importCurrPID = PID
					found = true
					break
				end
			end
			if ( found == false ) then
				SKG_Print( SKGL["SKG_MSG_IMPORT_ENDPHASE2"] )
				-- execute on phase 3
				-- insert all entries in the imported players list into our
				-- main list
				local db = SKG.db.profile
				local pList = db.Players
				for PID, pInfo in pairs( SKG.Import.Players ) do
					if ( pList[PID] ) then
						-- it exists, no touchie
					else
						pList[PID] = pInfo
					end
				end
				local rList = db.RollLists
				for listName, listData in pairs( SKG.Import.RollLists ) do
					rList[listName] = listData
					-- clean up lastmod and make a snapshot
					SKG_CleanUpImport( listName )
				end
				-- force all relevant stuff to recalculate
				SKG_UpdateLists()
				SKG_ScrollFrame.selected = 0
				SKG_UpdateSPlayers()
				SKG_UpdateCurrentList()
				SKG_UpdateMainsChooser()
				SKG_UpdateToonChooser()

				if ( SKG.inRaid == true ) then
					SKG_UpdateRaiders()
				end

				SKG.Import = {}
				SKG.Import.Players = {}
				SKG.Import.RollLists = {}
				SKG.importClassSelections = {}
				SKG.importSelectedClass = 0
				SKG.importCurrPID = ""

				SKG_Print( SKGL["SKG_MSG_IMPORT_ENDPHASE3"] )
			else
				SKG_CCF_NameText:SetText( pName )
				SKG_ChooseClassFrame:Show()
			end
		end
	end )
	SKG_ImportTimerFrame:Hide()
